#module "MQOanalyzer"

	#enum CHUNK_SKIP		= 0
	#enum CHUNK_MATERIAL
	#enum CHUNK_OBJECT
	#enum CHUNK_PARAM
	
	#enum MQOOBJ_DEPTH = 0
	#enum MQOOBJ_FOLDING
	#enum MQOOBJ_SCALE
	#enum MQOOBJ_ROTATION
	#enum MQOOBJ_TRANSLATION
	#enum MQOOBJ_PATCH
	#enum MQOOBJ_SEGMENT
	#enum MQOOBJ_VISIBLE
	#enum MQOOBJ_LOCKING
	#enum MQOOBJ_SHADING
	#enum MQOOBJ_FACET
	#enum MQOOBJ_COLOR
	#enum MQOOBJ_COLOR_TYPE
	#enum MQOOBJ_MIRROR
	#enum MQOOBJ_MIRROR_AXIS
	#enum MQOOBJ_MIRROR_DIS
	#enum MQOOBJ_PARAM
	
	;ꉞǎgȂ
	#enum	MAT_SHADER = 0
	#enum	MAT_VCOL
	#enum	MAT_COL
	#enum	MAT_DIF
	#enum	MAT_AMB
	#enum	MAT_EMI
	#enum	MAT_SPC
	#enum	MAT_POWER
	#enum	MAT_PROJ_TYPE
	#enum	MAT_PROJ_POS
	#enum	MAT_PROJ_SCALE
	#enum	MAT_PROJ_ANGLE
	#enum	MAT_TEX = 0
	#enum	MAT_APLANE
	#enum	MAT_BUMP
	#enum	MAT_PARAM

#deffunc MQOanalizerinit
	dim tmp_vertno, 4	;S_|S܂
	sdim mqoobjparamname, 32, MQOOBJ_PARAM
	mqoobjparamname.MQOOBJ_DEPTH		= "depth ";ʂ邽߂ɖɃXy[X
	mqoobjparamname.MQOOBJ_FOLDING		= "folding "
	mqoobjparamname.MQOOBJ_SCALE		= "scale "
	mqoobjparamname.MQOOBJ_ROTATION		= "rotation "
	mqoobjparamname.MQOOBJ_TRANSLATION	= "translation "
	mqoobjparamname.MQOOBJ_PATCH		= "patch "
	mqoobjparamname.MQOOBJ_SEGMENT		= "segment "
	mqoobjparamname.MQOOBJ_VISIBLE		= "visible "
	mqoobjparamname.MQOOBJ_LOCKING		= "locking "
	mqoobjparamname.MQOOBJ_SHADING		= "shading "
	mqoobjparamname.MQOOBJ_FACET		= "facet "
	mqoobjparamname.MQOOBJ_COLOR		= "color "
	mqoobjparamname.MQOOBJ_COLOR_TYPE	= "color_type "
	mqoobjparamname.MQOOBJ_MIRROR		= "mirror "
	mqoobjparamname.MQOOBJ_MIRROR_AXIS	= "mirror_axis "
	mqoobjparamname.MQOOBJ_MIRROR_DIS	= "mirror_dis "
	return
	
#deffunc chkchunktype str _chunkstr
	tmps_chunk = getpath(_chunkstr, 16)
	chunk_id = 0
	if instr(tmps_chunk, 0, "object") ! -1{
		chunk_id = CHUNK_OBJECT
	}
	if instr(tmps_chunk, 0, "material") ! -1{
		chunk_id = CHUNK_MATERIAL
	}
	return chunk_id

#deffunc getobjno str _chunkstr
	chkflag = -1
	repeat objnum
		if _chunkstr = objname.cnt {
			chkflag = cnt
			break
		}
	loop
	return chkflag

#deffunc getobjname str _chunkstr
	tmps_chunk = _chunkstr	;ɂ͂Ȃ
	tmp_pos = instr(tmps_chunk, 0, "\"") + 1
	getstr tmps_name, tmps_chunk, tmp_pos, '"'

	notesel objlist
	chkflag = -1	
	if objnum{
		chk_name = ""
		repeat objnum
			noteget chk_name, cnt
			if chk_name = tmps_name {
				chkflag = 0
				break
			}
		loop
	}
	if chkflag{
		noteadd tmps_name
		objnum ++
	}
	noteunsel

	return

#deffunc getmatname int _curline
	tmp_curline = _curline
	noteget tmps_chunk, tmp_curline
	tmp_pos = instr(tmps_chunk, 0, " ") + 1
	getstr tmps_name, tmps_chunk, tmp_pos, '{'
	tmp_matnum = int(tmps_name)
	dim matindex, tmp_matnum

	repeat tmp_matnum
		tmp_matno = cnt
		matindex.tmp_matno = matnum;CfbNX
		tmp_curline ++
		noteget tmps_chunk, tmp_curline
		tmp_pos = instr(tmps_chunk, 0, "\"") + 1
		getstr tmps_name, tmps_chunk, tmp_pos, '"';}eA
		;d`FbN
		notesel matlist
		chkflag = -1	
		if matnum{
			chk_name = ""
			repeat matnum
				noteget chk_name, cnt
				if chk_name = tmps_name {
					matindex.tmp_matno = cnt
					chkflag = 0
					break
				}
			loop
		}
		;mes strf("mat(%d)", tmp_matno)+strf("-> %d", matindex.tmp_matno)
		if chkflag{;dȂBVK}eAǉ
			noteadd tmps_name
			matnum ++
			noteunsel
			notesel matsetlist
			noteadd tmps_chunk
		}
		noteunsel
	loop

	return

#deffunc getobjinfo int _curline
	tmp_curline = _curline
	noteget tmps_chunk, tmp_curline
	tmp_pos = instr(tmps_chunk, 0, "\"") + 1
	getstr tmps_name, tmps_chunk, tmp_pos, '"'
	getobjno tmps_name
	objno = stat
	
	repeat mqomaxline;K
		tmp_curline ++
		noteget curstr, tmp_curline
		tmps_chunk = getpath(curstr, 16)	;ꉞ
		if instr(tmps_chunk, 0, "}") ! -1 : break
		repeat MQOOBJ_PARAM
			if instr(tmps_chunk, 0, mqoobjparamname.cnt) ! -1 : objinfochunk.cnt.objno = curstr
		loop
		tmp_pos = instr(tmps_chunk, 0, "face ") + 1
		if tmp_pos{;ʃ`N
			getstr tmps_name, tmps_chunk, tmp_pos, ' '
			tmp_pos += strsize
			getstr tmps_name, tmps_chunk, tmp_pos, '{'
			tmp_num = int(tmps_name)
			objfacenum.objno += tmp_num
			tmp_curline += tmp_num + 1
			continue
		}
		tmp_pos = instr(tmps_chunk, 0, "vertex ") + 1
		if tmp_pos{;_`N
			getstr tmps_name, tmps_chunk, tmp_pos, ' '
			tmp_pos += strsize
			getstr tmps_name, tmps_chunk, tmp_pos, '{'
			tmp_num = int(tmps_name)
			objvertnum.objno += tmp_num
			tmp_curline += tmp_num + 1
			continue
		}
	loop
	
	return

#deffunc getobjdata int _curline
	tmp_curline = _curline
	noteget tmps_chunk, tmp_curline
	tmp_pos = instr(tmps_chunk, 0, "\"") + 1
	getstr tmps_name, tmps_chunk, tmp_pos, '"'
	getobjno tmps_name
	objno = stat
	curvertoffset = objvertoffset.objno
	
	repeat mqomaxline;K
		tmp_curline ++
		noteget curstr, tmp_curline
		;mes curstr
		tmps_chunk = getpath(curstr, 16)	;ꉞ
		if instr(tmps_chunk, 0, "}") ! -1 : break
		tmp_pos = instr(tmps_chunk, 0, "vertex ") + 1
		if tmp_pos{;_`N
			getstr tmps_name, tmps_chunk, tmp_pos, ' '
			tmp_pos += strsize
			getstr tmps_name, tmps_chunk, tmp_pos, '{'
			tmp_num = int(tmps_name);_
			repeat tmp_num
				tmp_curline ++
				tmp_pos = 0
				noteget curstr, tmp_curline
				repeat 3
					getstr tmps_name, curstr, tmp_pos, ' '
					tmp_pos += strsize
					vertdata(cnt, objvertindex.objno + objvertoffset.objno) = double(tmps_name)
				loop
				objvertoffset.objno ++
			loop
			tmp_curline ++
			continue
		}
		
		tmp_pos = instr(tmps_chunk, 0, "face ") + 1
		if tmp_pos{;ʓ_`N
			getstr tmps_name, tmps_chunk, tmp_pos, ' '
			tmp_pos += strsize
			getstr tmps_name, tmps_chunk, tmp_pos, '{'
			tmp_num = int(tmps_name);IuWFNg̖ʐ
			repeat tmp_num
				tmp_curline ++
				tmp_pos = 0
				noteget curstr, tmp_curline
				getstr tmps_name, curstr, tmp_pos, ' '
				tmp_pos += strsize
				tmp_polynum = int(tmps_name)	;ʂ̒_
				tmp_pos += instr(curstr, tmp_pos, "(") + 1
				;mes tmp_pos
				repeat tmp_polynum
					if (cnt + 1) = tmp_polynum{
						getstr tmps_name, curstr, tmp_pos, ')';Ō̓Xy[X
					}else{
						getstr tmps_name, curstr, tmp_pos, ' '
					}
					tmp_pos += strsize
					;dialog  tmps_name
					tmp_vertno.cnt = int(tmps_name)
				loop
				tmp_pos += instr(curstr, tmp_pos, "M(") + 2;}eA
				getstr tmps_name, curstr, tmp_pos, ')'
				tmp_pos += strsize
				tmp_matno = int(tmps_name)

				;
				tmps_chunk = strf("\t\t%d V(", tmp_polynum)
				repeat tmp_polynum
					if (cnt + 1) = tmp_polynum{
						tmps_chunk += strf("%d", tmp_vertno.cnt + curvertoffset)
					}else{
						tmps_chunk += strf("%d ", tmp_vertno.cnt + curvertoffset)
					}
				loop
				tmps_chunk += strf(") M(%d", matindex.tmp_matno)
				getstr tmps_name, curstr, tmp_pos - 1, '\n'
				tmps_chunk += tmps_name
				notesel objfacelist
				noteadd tmps_chunk
				noteunsel
				facedata(objfaceindex.objno + objfaceoffset.objno) = objfacelistindex
				objfaceoffset.objno ++
				objfacelistindex ++
			loop
			tmp_curline ++
			continue
		}
	loop
	
	return

#deffunc MQOscan str _filepath
	mes "[ANALIZE START]"
	mes "--scan phase"
	;IuWFNgƃ}eȂ擾
	objnum = 0
	objlist = ""
	matnum = 0
	matlist = ""
	matsetlist = ""

	mqobuf = ""
	notesel mqobuf
	noteload _filepath
	mqomaxline = notemax
	dim mqolineflag, mqomaxline / 4 + 1
	
	notesel mqobuf
	curstr = ""
	curline = 0
	repeat mqomaxline
		noteget curstr, curline
		chunkflag = instr(curstr, 0, "{");{邩ׂ
		if chunkflag ! -1{
			chkchunktype curstr
			poke mqolineflag, curline, stat
			switch stat
			case CHUNK_OBJECT
				getobjname curstr
			swbreak
			case CHUNK_MATERIAL
				getmatname curline
			swbreak
			swend
		}
		curline ++
	loop
	
	;IuWFNg̏ƒ_Ɩʂ̑擾
	mes "--count phase"
	dim objvertnum, objnum
	dim objfacenum, objnum
	sdim objinfochunk, 256, MQOOBJ_PARAM, objnum
	sdim objname, 64, objnum
	notesel objlist
	repeat objnum
		noteget objname.cnt, cnt
	loop
	noteunsel
	
	curstr = ""
	curline = 0
	repeat mqomaxline
		if peek(mqolineflag, curline) = CHUNK_OBJECT{
			getobjinfo curline
		}
		curline ++
	loop
	
	totalvert = 0
	totalface = 0
	dim objvertindex, objnum
	dim objfaceindex, objnum
	dim objvertoffset, objnum
	dim objfaceoffset, objnum
	repeat objnum
		objvertindex.cnt = totalvert
		objfaceindex.cnt = totalface
		totalvert += objvertnum.cnt
		totalface += objfacenum.cnt
	loop
	
	;_Ɩʃf[^
	mes "--analize phase"
	ddim vertdata, 3, totalvert
	objfacelist = ""
	objfacelistindex = 0
	dim facedata, totalface

	curstr = ""
	curline = 0
	repeat mqomaxline
		if peek(mqolineflag, curline) = CHUNK_OBJECT{
			getobjdata curline
		}
		curline ++
	loop
	mes "[ANALIZE FINISH]"

	return

#deffunc MQOoptisave str _filepath
	newmqobuf = "Metasequoia Document\nFormat Text Ver 1.0\n\n"
	notesel newmqobuf
	;ގ
	noteadd strf("Material %d {", matnum)
	noteadd matsetlist
	noteadd "}"
	;IuWF
	repeat objnum
		objno = cnt
		noteadd "Object \"" + objname.objno + "\"{";IuWFNgJn
		repeat MQOOBJ_PARAM
			;mes objinfochunk.cnt.objno
			if objinfochunk.cnt.objno ! "" {
				noteadd objinfochunk.cnt.objno
			}
		loop
		
		noteadd strf("\tvertex %d {", objvertnum.objno);_Jn
		repeat objvertnum.objno
			noteadd "\t\t" + strf("%f ", vertdata(0, cnt + objvertindex.objno)) + strf("%f ", vertdata(1, cnt + objvertindex.objno)) + strf("%f", vertdata(2, cnt + objvertindex.objno))
		loop
		noteadd "\t}";_I

		noteadd strf("\tface %d {", objfacenum.objno);ʊJn
		repeat objfacenum.objno
			notesel objfacelist
			noteget curstr, facedata(objfaceindex.objno + cnt)
			noteunsel
			noteadd curstr
		loop
		noteadd "\t}";ʏI

		noteadd "}"	;IuWFNgI
	loop
	
	noteadd "Eof"
	notesave _filepath
	return
	
#global